var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component, PropTypes } from 'react';
import { connect } from 'react-redux';
import { setIsETFOpen as _setIsETFOpen, toggleETF as _toggleETF } from './actions/actions';
import IconButton from 'material-ui/IconButton';

function IB(props) {
  var expandableTextFields = props.expandableTextFields,
      id = props.id,
      hideOnOpen = props.hideOnOpen,
      hideOnClose = props.hideOnClose,
      children = props.children,
      onTouchTap = props.onTouchTap;

  var open = expandableTextFields[id];

  if (open && hideOnOpen === true) {
    return null;
  }

  if (!open && hideOnClose === true) {
    return null;
  }

  return React.createElement(
    IconButton,
    {
      onTouchTap: onTouchTap },
    children
  );
}

var ETFIconButtonContainer = function (_Component) {
  _inherits(ETFIconButtonContainer, _Component);

  function ETFIconButtonContainer() {
    var _temp, _this, _ret;

    _classCallCheck(this, ETFIconButtonContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.onTouchTap = function () {
      var _this$props = _this.props,
          expandableTextFields = _this$props.expandableTextFields,
          toggleETF = _this$props.toggleETF,
          setIsETFOpen = _this$props.setIsETFOpen,
          value = _this$props.value,
          id = _this$props.id,
          onETFChange = _this$props.onETFChange,
          closeOthers = _this$props.closeOthers;


      if (value !== undefined) {
        setIsETFOpen(id, value);
      } else {
        toggleETF(id, closeOthers);
      }

      if (onETFChange !== undefined) {
        onETFChange(value !== undefined ? value : !expandableTextFields[id]);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ETFIconButtonContainer.prototype.render = function render() {
    var _props = this.props,
        expandableTextFields = _props.expandableTextFields,
        children = _props.children,
        id = _props.id,
        toggler = _props.toggler;


    return React.createElement(IB, _extends({
      onTouchTap: this.onTouchTap
    }, this.props));
  };

  return ETFIconButtonContainer;
}(Component);

process.env.NODE_ENV !== "production" ? ETFIconButtonContainer.propTypes = {
  id: PropTypes.string.isRequired,
  children: PropTypes.object.isRequired,
  toggleETF: PropTypes.func.isRequired,
  setIsETFOpen: PropTypes.func.isRequired,
  onETFChange: PropTypes.func,
  value: PropTypes.bool,
  hideOnOpen: PropTypes.bool,
  hideOnClose: PropTypes.bool,
  closeOthers: PropTypes.bool
} : void 0;

var mapStateToProps = function mapStateToProps(state) {
  var expandableTextFields = state.expandableTextFields;

  return {
    expandableTextFields: expandableTextFields
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setIsETFOpen: function setIsETFOpen(id, open) {
      dispatch(_setIsETFOpen(id, open));
    },
    toggleETF: function toggleETF(id, closeOthers) {
      dispatch(_toggleETF(id, closeOthers));
    }

  };
};

export default connect(mapStateToProps, mapDispatchToProps)(ETFIconButtonContainer);