function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { Component, PropTypes } from 'react';
import { connect } from 'react-redux';
import { setIsETFOpen, addETF } from './actions/actions';
import TextField from 'material-ui/TextField';

function TF(props) {
  var open = props.open,
      rest = _objectWithoutProperties(props, ['open']);

  if (!open) {
    return null;
  }

  return rest.children;
}

var ExpandableTextFieldContainer = function (_Component) {
  _inherits(ExpandableTextFieldContainer, _Component);

  function ExpandableTextFieldContainer() {
    _classCallCheck(this, ExpandableTextFieldContainer);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  ExpandableTextFieldContainer.prototype.render = function render() {
    var _props = this.props,
        expandableTextFields = _props.expandableTextFields,
        children = _props.children,
        id = _props.id;

    var open = expandableTextFields[id];

    return React.createElement(TF, {
      open: open,
      children: children
    });
  };

  return ExpandableTextFieldContainer;
}(Component);

process.env.NODE_ENV !== "production" ? ExpandableTextFieldContainer.propTypes = {
  id: PropTypes.string.isRequired,
  children: PropTypes.object.isRequired
} : void 0;

var mapStateToProps = function mapStateToProps(state) {
  var expandableTextFields = state.expandableTextFields;

  return {
    expandableTextFields: expandableTextFields
  };
};

export default connect(mapStateToProps)(ExpandableTextFieldContainer);