'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _actions = require('./actions/actions');

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function IB(props) {
  var expandableTextFields = props.expandableTextFields,
      id = props.id,
      hideOnOpen = props.hideOnOpen,
      hideOnClose = props.hideOnClose,
      children = props.children,
      onTouchTap = props.onTouchTap;

  var open = expandableTextFields[id];

  if (open && hideOnOpen === true) {
    return null;
  }

  if (!open && hideOnClose === true) {
    return null;
  }

  return _react2.default.createElement(
    _IconButton2.default,
    {
      onTouchTap: onTouchTap },
    children
  );
}

var ETFIconButtonContainer = function (_Component) {
  _inherits(ETFIconButtonContainer, _Component);

  function ETFIconButtonContainer() {
    var _temp, _this, _ret;

    _classCallCheck(this, ETFIconButtonContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.onTouchTap = function () {
      var _this$props = _this.props,
          expandableTextFields = _this$props.expandableTextFields,
          toggleETF = _this$props.toggleETF,
          setIsETFOpen = _this$props.setIsETFOpen,
          value = _this$props.value,
          id = _this$props.id,
          onETFChange = _this$props.onETFChange,
          closeOthers = _this$props.closeOthers;


      if (value !== undefined) {
        setIsETFOpen(id, value);
      } else {
        toggleETF(id, closeOthers);
      }

      if (onETFChange !== undefined) {
        onETFChange(value !== undefined ? value : !expandableTextFields[id]);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ETFIconButtonContainer.prototype.render = function render() {
    var _props = this.props,
        expandableTextFields = _props.expandableTextFields,
        children = _props.children,
        id = _props.id,
        toggler = _props.toggler;


    return _react2.default.createElement(IB, _extends({
      onTouchTap: this.onTouchTap
    }, this.props));
  };

  return ETFIconButtonContainer;
}(_react.Component);

process.env.NODE_ENV !== "production" ? ETFIconButtonContainer.propTypes = {
  id: _react.PropTypes.string.isRequired,
  children: _react.PropTypes.object.isRequired,
  toggleETF: _react.PropTypes.func.isRequired,
  setIsETFOpen: _react.PropTypes.func.isRequired,
  onETFChange: _react.PropTypes.func,
  value: _react.PropTypes.bool,
  hideOnOpen: _react.PropTypes.bool,
  hideOnClose: _react.PropTypes.bool,
  closeOthers: _react.PropTypes.bool
} : void 0;

var mapStateToProps = function mapStateToProps(state) {
  var expandableTextFields = state.expandableTextFields;

  return {
    expandableTextFields: expandableTextFields
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setIsETFOpen: function setIsETFOpen(id, open) {
      dispatch((0, _actions.setIsETFOpen)(id, open));
    },
    toggleETF: function toggleETF(id, closeOthers) {
      dispatch((0, _actions.toggleETF)(id, closeOthers));
    }

  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(ETFIconButtonContainer);
module.exports = exports['default'];