'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _actions = require('./actions/actions');

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function TF(props) {
  var open = props.open,
      rest = _objectWithoutProperties(props, ['open']);

  if (!open) {
    return null;
  }

  return rest.children;
}

var ExpandableTextFieldContainer = function (_Component) {
  _inherits(ExpandableTextFieldContainer, _Component);

  function ExpandableTextFieldContainer() {
    _classCallCheck(this, ExpandableTextFieldContainer);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  ExpandableTextFieldContainer.prototype.render = function render() {
    var _props = this.props,
        expandableTextFields = _props.expandableTextFields,
        children = _props.children,
        id = _props.id;

    var open = expandableTextFields[id];

    return _react2.default.createElement(TF, {
      open: open,
      children: children
    });
  };

  return ExpandableTextFieldContainer;
}(_react.Component);

process.env.NODE_ENV !== "production" ? ExpandableTextFieldContainer.propTypes = {
  id: _react.PropTypes.string.isRequired,
  children: _react.PropTypes.object.isRequired
} : void 0;

var mapStateToProps = function mapStateToProps(state) {
  var expandableTextFields = state.expandableTextFields;

  return {
    expandableTextFields: expandableTextFields
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps)(ExpandableTextFieldContainer);
module.exports = exports['default'];